#include <TFile.h>
#include <TTree.h>
#include <TClonesArray.h>
#include <TRandom3.h>
#include <TMath.h>
#include "A.h"
#include "B.h"

using namespace TMath;

void BuildTree()
{
  TFile *outFile = new TFile("test.root","RECREATE");
  TTree *outTree = new TTree("data","Tree with test data.");
  TClonesArray a("A",10);
  outTree->Branch("a", &a);
  
  for(int i=0; i<10; i++){
    TRandom3 rGen(0);
    a.Clear("C");
    int nA = Floor(rGen.Uniform(1,5)); //Between 1 and 4 instances of A per event.
    for(int j=0; j<nA; j++){
      A *aj = (A*)a.ConstructedAt(j);
      aj->varA = rGen.Uniform(0,1);
      int nB = Floor(rGen.Uniform(1,5)); //Same
      for(int k=0; k<nB; k++){
        B bk;
        bk.varB = rGen.Uniform(0,1);
        aj->PushB(bk);
      }
    }
    outTree->Fill();
  }
  outTree->Write();
  outFile->Close();
}
